Module java.base
Package java.lang.annotation

## Enum ElementType

- java.lang.Object
- - java.lang.Enum<ElementType>
  - - java.lang.annotation.ElementType

All Implemented Interfaces:
  `Serializable`, `Comparable<ElementType>`

    public enum ElementType
    extends Enum<ElementType>

The constants of this enumerated type provide a simple classification of the syntactic locations where annotations may appear in a Java program. These constants are used in `Target` meta-annotations to specify where it is legal to write annotations of a given type.

The syntactic locations where annotations may appear are split into declaration contexts , where annotations apply to declarations, and type contexts , where annotations apply to types used in declarations and expressions.

The constants `ANNOTATION_TYPE`, `CONSTRUCTOR`, `FIELD`, `LOCAL_VARIABLE`, `METHOD`, `PACKAGE`, `MODULE`, `PARAMETER`, `TYPE`, and `TYPE_PARAMETER` correspond to the declaration contexts in JLS 9.6.4.1.

For example, an annotation whose type is meta-annotated with `@Target(ElementType.FIELD)` may only be written as a modifier for a field declaration.

The constant `TYPE_USE` corresponds to the type contexts in JLS 4.11, as well as to two declaration contexts: type declarations (including annotation type declarations) and type parameter declarations.

For example, an annotation whose type is meta-annotated with `@Target(ElementType.TYPE_USE)` may be written on the type of a field (or within the type of the field, if it is a nested, parameterized, or array type), and may also appear as a modifier for, say, a class declaration.

The `TYPE_USE` constant includes type declarations and type parameter declarations as a convenience for designers of type checkers which give semantics to annotation types. For example, if the annotation type `NonNull` is meta-annotated with `@Target(ElementType.TYPE_USE)`, then `@NonNull` `class C {...}` could be treated by a type checker as indicating that all variables of class `C` are non-null, while still allowing variables of other classes to be non-null or not non-null based on whether `@NonNull` appears at the variable's declaration.

Since:
  1.5
See The Java™ Language Specification:
  9.6.4.1 @Target, 4.1 The Kinds of Types and Values

### Enum Constant Summary

Enum Constants
`ANNOTATION_TYPE` Annotation type declaration
`CONSTRUCTOR` Constructor declaration
`FIELD` Field declaration (includes enum constants)
`LOCAL_VARIABLE` Local variable declaration
`METHOD` Method declaration
`MODULE` Module declaration.
`PACKAGE` Package declaration
`PARAMETER` Formal parameter declaration
`TYPE` Class, interface (including annotation type), or enum declaration
`TYPE_PARAMETER` Type parameter declaration
`TYPE_USE` Use of a type

### Method Summary

All Methods Static Methods Concrete Methods
`static ElementType` `valueOf​(String name)` Returns the enum constant of this type with the specified name.
`static ElementType[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods declared in class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods declared in class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### TYPE

    public static final ElementType TYPE

Class, interface (including annotation type), or enum declaration

#### FIELD

    public static final ElementType FIELD

Field declaration (includes enum constants)

#### METHOD

    public static final ElementType METHOD

Method declaration

#### PARAMETER

    public static final ElementType PARAMETER

Formal parameter declaration

#### CONSTRUCTOR

    public static final ElementType CONSTRUCTOR

Constructor declaration

#### LOCAL_VARIABLE

    public static final ElementType LOCAL_VARIABLE

Local variable declaration

#### ANNOTATION_TYPE

    public static final ElementType ANNOTATION_TYPE

Annotation type declaration

#### PACKAGE

    public static final ElementType PACKAGE

Package declaration

#### TYPE_PARAMETER

    public static final ElementType TYPE_PARAMETER

Type parameter declaration

Since:
  1.8

#### TYPE_USE

    public static final ElementType TYPE_USE

Use of a type

Since:
  1.8

#### MODULE

    public static final ElementType MODULE

Module declaration.

Since:
  9

### Method Detail

#### values

    public static ElementType[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (ElementType c : ElementType.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static ElementType valueOf​(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null